<?php
/*
Copyright (C) 2009 Anja S. Gritz <http://www.goeritz.net>
This file is part of phpPanelAdmin.

phpPanelAdmin is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
any later version.

phpPanelAdmin is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with phpPanelAdmin. If not, see <http://www.gnu.org/licenses/>.
*/

session_start();
if(!isset($_SESSION['admin']))
{
echo "Processing impossible!<br>";
echo "<a href=\"index.php\">Login?</a>";
}
else //cookie is there
{
?>

<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<html><head>
<title>Help</title>
<meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1">
</head><body>
<?php require 'header.php'; ?>

<p>[ <a href="#search">search help</a> |  <a href="#e-mail">e-mail help</a> | <a href="#panel_overview">panel overview help</a> | <a href="#duplicates">duplicates help</a>  | <a href="#sql_query">sql query help</a> ]</p>
<h1>Search Help<a name="search"></a></h1>
On the search page you can search for one or more panelists by one criterion or by a combination of several criteria.
<p>By default, the search is case-insensitive, that is the search character 'p' matches 'p' and 'P' . To conduct a case-sensitive search, choose the respective radio button before you search. </p>
<p>With the search type 'LIKE' you can use wildcards: The percentage sign '%' matches any number of characters, even zero characters; an underscore '_' matches exactly one character. Wildcards match any characters, but they do not match a NULL value. </p>
<p>If you want to search for an underscore '_' or for the percentage sign '%', you need to use a preceding backslash '\' as an escape character because otherwise '%' and '_' are considered wildcards and not literal characters.</p>
<p><b>Examples of LIKE searches:</b></p>
<table width="90%" border="0">
 <tr>
  <th align="left">Manual pattern</th>
  <th align="left">Search result</th>
 </tr>
 <tr>
  <td>P_____</td>
  <td>values with six letters beginning with 'P'</td>
 </tr>
 <tr>
  <td>%ft</td>
  <td>values ending with 'ft'</td>
 </tr>
 <tr>
  <td>_%p%</td>
  <td>values with a 'p' after the second letter</td>
 </tr>
 <tr>
  <td>%_</td>
  <td>values with a minimum length of 1</td>
 </tr>
 <tr>
  <td>&nbsp;</td>
  <td>&nbsp;</td>
 </tr>
 <tr>
  <td> \% </td>
  <td> matches one '%' character </td>
 </tr>
 <tr>
  <td>\_</td>
  <td>matches one '_' character </td>
 </tr>
 <tr>
  <td>%\_%</td>
  <td>value with any number of characters, whereby the value must contain an &quot;_&quot;</td>
 </tr>
 <tr>
  <td>%\\%</td>
  <td>value with any number of characters preceding a backslash followed by any number of characters </td>
 </tr>
 <tr>
  <td>&nbsp;</td>
  <td>NULL value </td>
 </tr>
</table>
<p>With the other four search types  '&#61;', '&lt;', '&gt;' and IN you cannot use wildcard characters.</p>
<p>With the search type 'IN' you can enter a comma-separated set of values. </p>
<p><b>Examples of IN searches:</b></p>
<table width="90%" border="0">
 <tr>
  <th align="left">Manual pattern</th>
  <th align="left">Search result</th>
 </tr>
 <tr>
  <td>23,567,111</td>
  <td>values (id) 23, 567 and 111, if present</td>
 </tr>
  <tr>
   <td>Sue,Ellen</td>
   <td>values (name) Sue and Ellen, if present</td>
 </tr>
</table>
<p>
<p><a href="javascript:history.back()">back</a>
</p>
<hr>
<h1>E-Mail Help<a name="e-mail" id="e-mail"></a></h1>
<p>You may choose one of the existing e-mail templates. E-mail templates can be created, edited, and deleted under the link &quot;e-mail templates&quot; in the top menu that can be reached from all pages within phpPanelAdmin.</p>
<p> In the e-mail subject and body you can include personalized text that is fetched from the database prior to sending the e-mail. To include a piece of personalized text you need to enter a placeholder.</p>
<p> The placeholder needs to comply with the format ##name_of_respective_variable_in_profile data##. For example, if you would like to address the receiver of the e-mail by his or her forename you could write &quot;Hello ##forename##&quot;.
This presupposes that there actually is a profile variable called &quot;forename&quot; in the profile data table. This capability of including tailored text in e-mail is especially useful when inviting panelists to a study. To keep track of respondents it is recommended to append their id or other unique identifiers to the URL of the study and log this identifier on the first page of the study.</p>
<p> Finally, you may alter the default size of the e-mail batch that is sent at one go from 50 to any other positive integer. It is recommended that you successively sound out the capacity of your mail server by starting small and prudently increasing the batch size if sending out the messages has worked fine in the past.</p>
<p>  <a href="javascript:history.back()">back</a></p>
<hr>
<h1>Panel Overview Help<a name="panel_overview" id="panel_overview"></a></h1>
<p>Through the function "panel overview" you can obtain real-time panel statistics at a glance: The leftmost column lists all profile variables. Next to each variable, in a drop-down menu there is a summary of all values of that variable.</p>
<p> The format is "(absolute frequency) (relative frequency) : value".  </p>
<p> For example, let us assume there exists the panel variable "sex" and four panelists in the panel. Unfolding the adjacent drop-down menu reveals three menu items "(1) (25%) : 0", "(1) (25%) : 1", and "(2) (50%) : 2".  </p>
<p> Depending on the values you have set in the registration form, this might read: One panelist, that is, 25% of all panelists, has a value of "0" in the sex variable. Value "0" indicates that he or she did not give his or her sex. Next, one panelist, that is, 25% of all panelists, has a value of "1" in the sex variable. That is, she is female. Finally, there are two panelists, who make up 50% of the panel population. They have a value of "2" in the sex variable, and hence are male.</p>
<p>  <a href="javascript:history.back()">back</a></p>
<hr>
<h1>Duplicates Help<a name="duplicates"></a></h1>
<p>One can search for duplicates by checking one criterion or several criteria at the same time. Upon hitting "Identify Duplicates" all panelists will be displayed that have identical values in the checked criteria. <br>
One can select whether cases with empty values in the search criteria are skipped or not. Skipping empty values speeds up the search. In general, searching duplicates puts a high load on the database. That is why there often will be a timeout before the search is completed, especially if there are many records in the database.</p>
<p> If duplicates are actually there, one can now check one or several of the affected panelists and either view and alter their profile data or delete them.</p>
<p>  <a href="javascript:history.back()">back</a></p>
<hr>
<h1>SQL Query Help<a name="sql_query"></a></h1>
<p>Through the interface "sql query" the  user can send one query at a time written in SQL (Structured Query Language) to one of the database tables that make up phpPanelAdmin.</p>
<p>To query the profile data table use "$db_table", to query the table that contains panel administrators use "$db_table_admins", to query the table that contains deleted panelists use "$db_table_deleted".</p>
<p>For security reasons, some potentially risky queries might be blocked. Despite this safeguard, this interface is only intended for the expert user to administer the panel even more efficiently.</p>
<p>  <b>Examples: (presuppose that the respective fields and values exist)</b></p>
<p>  SELECT * FROM $db_table WHERE gender=1 <br>
Display row(s) from the profile data table where the variable &quot;gender&quot; has a value of &quot;1&quot;</p>
<p> UPDATE $db_table SET name=&quot;Smith&quot; WHERE id=8 <br>
Set the value of the variable called &quot;name&quot; to the value &quot;Smith&quot; in profile data table in row(s) where the variable &quot;id&quot; is set to a value of &quot;8&quot;</p>
<p>ALTER TABLE $db_table ADD participation VARCHAR(2) <br>
Add a column called &quot;participation&quot; that can hold values consisting of up to two alphanumeric characters to the profile data table.</p>
<p> UPDATE $db_table SET participation=1 WHERE id IN (65,78,5400,5409)<br>
Change the current value of the &quot;participation&quot; variable to value &quot;1&quot; in profile data table with all panelists whose id is in the comma-separated array (65,78,5400,5409)</p>
<p> UPDATE $db_table SET points=points+2 WHERE id IN (65,78,5400,5409)<br>
Credit a reward of 2 loyalty points to variable &quot;points&quot; in profile data table to all panelists whose id is in the comma-separated array (65,78,5400,5409)</p>
<p> INSERT INTO $db_table VALUES () <br>
Insert a new row into the profile data table while accepting the next available number in the autoincrement id-variable.</p>
<p> ALTER TABLE $db_table_deleted DROP COLUMN gender <br>
Delete column &quot;gender&quot; from the table that contains deleted panelists.
<p> LOAD DATA LOCAL INFILE 'D:/data.tab' INTO TABLE $db_table (id,gender)<br>
Import external data into variables &quot;id&quot; and &quot;gender&quot; in profile data table from tab-separated values file &quot;data.tab&quot; on drive D:.
</p>
<p>  <a href="javascript:history.back()">back</a></p>
</body></html>
<?php
}
?>
