<?php
/*
Copyright (C) 2009 Anja S. Gritz <http://www.goeritz.net>
This file is part of phpPanelAdmin.

phpPanelAdmin is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
any later version.

phpPanelAdmin is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with phpPanelAdmin. If not, see <http://www.gnu.org/licenses/>.
*/

session_start();
if(!isset($_SESSION['admin']))
{
echo "Processing impossible!<br>";
echo "<a href=\"index.php\">Login?</a>";
}

//cookie is there
else
{
echo "<html><head><title>Sampling</title></head><body>";
require 'header.php';
echo "<h1>Sampling</h1>";
	//draw sample was requested
	if ((isset($_POST['toolbutton_draw_sample'])) OR (isset($_POST['toolbutton_all_in_sample'])))
	{
		if (isset($_POST['toolbutton_draw_sample']))
		{
			/* check whether requested No of sample units is unsigned integer and not greater than No of selected panelists */
			if (($_POST['no_in_sample'] < 1) OR ($_POST['no_in_sample'] > $_POST['counted']))
			{
			echo "The sample size you set is not a positive integer or larger than the number of selected panelists.";
			echo "<br><br><a href=\"javascript:history.back()\">back</a>";
			mysqli_close($link);
			exit;
			}
		}

	/* display form to ask which variable at what value shall be assigned to sample */
	?>
	 Create or choose a variable and set the value for this variable:
	 <br><br><form action="<?php echo $_SERVER['PHP_SELF'] ?>" method="post" name="sample_var">
	 <input name="sql2" type="hidden" value="<?php echo $_POST['sql2'] ?>">
	 <input name="no_in_sample" type="hidden" value="<?php echo $_POST['no_in_sample'] ?>">
	 Name of new variable: <input name="varname_new" type="text" size="50" maxlength="230"><br><br>
	 Use existing variable:
	 <select name="varname_old">
	<option value="0">select variable here unless you create a new one</option>
	<?php

	//get existing fields from db
	$sql = "SELECT * FROM $db_table LIMIT 1 ";
	$result = mysqli_query($link, $sql) or die ('Unable to Select from DB');

		/* populate drop-down menu with field name as long as field name starts with "sample_" */
		for ($d = 0; $d < mysqli_field_count($link); $d++)
		{

			$finfo = mysqli_fetch_field_direct($result, $d);

			//as long as field name starts with "sample_"
			if (preg_match("#^sample_#i", $finfo->name))
			{
			echo "<option value=\"".$finfo->name."\"";
			echo ">".$finfo->name."</option>";
			}
		}
	?>
	</select><br><br><br>
	 Set value of new or existing variable: <input name="varvalue" type="text" size="10" maxlength="255"><br><br><br>
	 <input name="toolbutton_proceed_sampling" type="submit" title="Submit Proceed Form" value="Proceed"></form>

	 <?php
	}

	/* Proceed was requested (i.e., form with var name and value was submitted)  */
	elseif (isset($_POST['toolbutton_proceed_sampling']))
	{
		//new var name is entered
		if (!empty($_POST['varname_new']))
		{
			//check whether new var name is valid
			if (!preg_match ('#^[a-zA-Z_][a-zA-Z0-9_]*$#', $_POST['varname_new']))
			{
			echo 'The variable name is invalid. A valid variable name starts with a letter or underscore, followed by any number of letters, numbers, or underscores, but no special characters and umlauts.';
			echo "<br><br><a href=\"javascript:history.back()\">back</a>";
			mysqli_close($link);
			exit;
			}

			elseif (!empty($_POST['varname_old']))
			{
			echo "You may choose a new variable <b>or</b> an existing one, but not both at the same time. ";
			echo "<br><br><a href=\"javascript:history.back()\">back</a>";
			mysqli_close($link);
			exit;
			}
		}
		//new var name is not entered
		else
		{
			//check whether old var name is entered
			if (empty($_POST['varname_old']))
			{
			echo "You need to choose a new variable or an existing one. ";
			echo "<br><br><a href=\"javascript:history.back()\">back</a>";
			mysqli_close($link);
			exit;
			}
		}

		//check whether var value is valid
		if (empty($_POST['varvalue']))
		{
		echo "You need to set a value for the sampling variable.";
		echo "<br><br><a href=\"javascript:history.back()\">back</a>";
		}

		//var name and value are valid
		else
		{
			//new variable is created
			if (!empty($_POST['varname_new']))
			{
			//create column
			$sql8 = "ALTER TABLE $db_table ADD sample_".date('Ymd')."_$_POST[varname_new] VARCHAR(255)";
			$result1 = mysqli_query($link, $sql8) or die( "A variable of this name already exists. Please choose another variable name. ".mysqli_error($link)."<br><br><a href=\"javascript:history.back()\">back</a>");

			//compose db query
			$sql9 = "UPDATE $db_table SET sample_".date('Ymd')."_$_POST[varname_new]='$_POST[varvalue]' $_POST[sql2] ORDER BY RAND()";
				//sample size was defined
				if ($_POST['no_in_sample'])
				{
				$sql9 .= " LIMIT $_POST[no_in_sample]";
				}

			//execute query
			$result2 = mysqli_query($link, $sql9) or die( "Unable to write in DB! ".mysqli_error($link));
			}

			//old variable is used
			else
			{
			//compose db query
			$sql9 = "UPDATE $db_table SET $_POST[varname_old]='$_POST[varvalue]' $_POST[sql2] ORDER BY RAND()";
				//sample size was defined
				if ($_POST['no_in_sample'])
				{
				$sql9 .= " LIMIT $_POST[no_in_sample]";
				}

			//execute query
			$result2 = mysqli_query($link, $sql9) or die( "Unable to write in DB! ".mysqli_error($link));
			}

		echo "The sample has been drawn. ";
		echo "<br><br><a href=\"search.php\">back to search</a>";
		}
	}
mysqli_close($link);
}
?>